Index: src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java	(revision 4677)
+++ src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java	(revision 4678)
@@ -55,469 +55,490 @@
  * A database aware Class implementing callback methods for the SAX parser to
  * call when processing the XML stream and generating events
  */
-public class Eml210SAXHandler extends DBSAXHandler implements
-        AccessControlInterface
-{
+public class Eml210SAXHandler extends DBSAXHandler implements AccessControlInterface {
 
-    private boolean processTopLevelAccess = false;
+	private boolean processTopLevelAccess = false;
 
-    private boolean processAdditionalAccess = false;
+	private boolean processAdditionalAccess = false;
 
-    private boolean processOtherAccess = false;
+	private boolean processOtherAccess = false;
 
-    private AccessSection accessObject = null;
+	private AccessSection accessObject = null;
 
-    private AccessRule accessRule = null;
+	private AccessRule accessRule = null;
 
-    private Vector<AccessSection> accessObjectList = new Vector<AccessSection>(); // store every access rule
+	private Vector<AccessSection> accessObjectList = new Vector<AccessSection>(); // store
+																					// every
+																					// access
+																					// rule
 
-    private Hashtable<String,AccessSection> topLevelAccessControlMap = new Hashtable<String,AccessSection>();
+	private Hashtable<String, AccessSection> topLevelAccessControlMap = new Hashtable<String, AccessSection>();
 
-    private Hashtable<String,AccessSection> additionalAccessControlMap = new Hashtable<String,AccessSection>();// store
+	private Hashtable<String, AccessSection> additionalAccessControlMap = new Hashtable<String, AccessSection>();// store
 
-    //subtree access for single additionalmetacat
-    private Vector<Hashtable<String,AccessSection>> additionalAccessMapList = new Vector<Hashtable<String,AccessSection>>();// store maps for
+	// subtree access for single additionalmetacat
+	private Vector<Hashtable<String, AccessSection>> additionalAccessMapList = new Vector<Hashtable<String, AccessSection>>();// store
+																																// maps
+																																// for
 
-    // every additionalmetadata
-    private Vector<String> describesId = new Vector<String>(); // store the ids in
+	// every additionalmetadata
+	private Vector<String> describesId = new Vector<String>(); // store the ids
+																// in
 
-    //additionalmetadata/describes
-    private Stack<SubTree> subTreeInfoStack = new Stack<SubTree>();
+	// additionalmetadata/describes
+	private Stack<SubTree> subTreeInfoStack = new Stack<SubTree>();
 
-    private Vector<SubTree> subTreeList = new Vector<SubTree>();// store the final subtree
+	private Vector<SubTree> subTreeList = new Vector<SubTree>();// store the
+																// final subtree
 
-    // MCD - Removed the following lines.  They are used for node level access control
-    // which is not yet implemented in EML 2.1.0
-	// private Hashtable<String,SubTree> unChangeableSubTreeHash = new Hashtable<String,SubTree>();
-	// private Stack<NodeRecord> currentUnChangeableSubtreeNodeStack = new Stack<NodeRecord>();
+	// MCD - Removed the following lines. They are used for node level access
+	// control
+	// which is not yet implemented in EML 2.1.0
+	// private Hashtable<String,SubTree> unChangeableSubTreeHash = new
+	// Hashtable<String,SubTree>();
+	// private Stack<NodeRecord> currentUnChangeableSubtreeNodeStack = new
+	// Stack<NodeRecord>();
 	// private boolean startCriticalSubTree = false;
-    // private boolean firstElementForCriticalSubTree = false;
-    // private String firstElementNameForCriticalSubTree;
+	// private boolean firstElementForCriticalSubTree = false;
+	// private String firstElementNameForCriticalSubTree;
+	
+	private boolean needToCheckAccessModule = false;
 
-    private boolean needToCheckAccessModule = false;
+	private Vector<AccessSection> unChangeableAccessSubTreeVector = new Vector<AccessSection>();
 
-    private Vector<AccessSection> unChangeableAccessSubTreeVector = new Vector<AccessSection>();
+	private Stack<NodeRecord> currentUnchangeableAccessModuleNodeStack = new Stack<NodeRecord>();
 
-    private Stack<NodeRecord> currentUnchangeableAccessModuleNodeStack = new Stack<NodeRecord>();
+	private AccessSection topAccessSection;
 
-    private AccessSection topAccessSection;
+	// we need an another stack to store the access node which we pull out just
+	// from xml. If a reference happened, we can use the stack the compare nodes
+	private Stack<NodeRecord> storedAccessNodeStack = new Stack<NodeRecord>();
 
-    // we need an another stack to store the access node which we pull out just
-    // from xml. If a reference happened, we can use the stack the compare nodes
-    private Stack<NodeRecord> storedAccessNodeStack = new Stack<NodeRecord>();
+	// vector stored the data file id which will be write into relation table
+	private Vector<String> onlineDataFileIdInRelationVector = new Vector<String>();
 
-    // vector stored the data file id which will be write into relation table
-    private Vector<String> onlineDataFileIdInRelationVector = new Vector<String>();
+	// vector stored the data file id which will be write top access rules to
+	// access table
+	private Vector<String> onlineDataFileIdInTopAccessVector = new Vector<String>();
 
-    // vector stored the data file id which will be write top access rules to
-   // access table
-    private Vector<String> onlineDataFileIdInTopAccessVector = new Vector<String>();
+	// Indicator of inline data
+	private boolean handleInlineData = false;
 
-    // Indicator of inline data
-    private boolean handleInlineData = false;
+	private Hashtable<String, String> inlineDataNameSpace = null;
 
-    private Hashtable<String,String> inlineDataNameSpace = null;
+	private FileWriter inlineDataFileWriter = null;
 
-    private FileWriter inlineDataFileWriter = null;
+	private String inlineDataFileName = null;
 
-    private String inlineDataFileName = null;
+	DistributionSection currentDistributionSection = null;
 
-    // This variable keeps a counter of each distribution element.  This index will
-    // be used to name the inline data file that gets written to disk, and to strip
-    // inline data from the metadata document on file if the user does not have read
-    // access.
+	Vector<DistributionSection> allDistributionSections = new Vector<DistributionSection>();
+
+	// This variable keeps a counter of each distribution element. This index
+	// will be used to name the inline data file that gets written to disk, and to
+	// strip inline data from the metadata document on file if the user does not have
+	// read access.
 	private int distributionIndex = 0;
 
+	// private String distributionOnlineFileName = null;
+
 	// This is used to delete inline files if the xml does not parse correctly.
-    private Vector<String> inlineFileIdList = new Vector<String>();
+	private Vector<String> inlineFileIdList = new Vector<String>();
 
-    // Constant
-    private static final String EML = "eml";
-    
-    private static final String DISTRIBUTION = "distribution";
+	// Constant
+	private static final String EML = "eml";
 
-    private static final String ORDER = "order";
+	private static final String DISTRIBUTION = "distribution";
 
-    private static final String ID = "id";
+	private static final String ORDER = "order";
 
-    private static final String REFERENCES = "references";
+	private static final String ID = "id";
 
-    public static final String INLINE = "inline";
+	private static final String REFERENCES = "references";
 
-    private static final String ONLINE = "online";
+	public static final String INLINE = "inline";
 
-    private static final String URL = "url";
+	private static final String ONLINE = "online";
 
-    // private static final String PERMISSIONERROR = "User tried to update a subtree "
-    //        + "when they don't have write permission!";
+	private static final String URL = "url";
 
-    private static final String UPDATEACCESSERROR = "User tried to update an "
-            + "access module when they don't have \"ALL\" permission!";
+	// private static final String PERMISSIONERROR = "User tried to update a
+	// subtree "
+	// + "when they don't have write permission!";
 
-    private static final String TOPLEVEL = "top";
+	private static final String UPDATEACCESSERROR = "User tried to update an "
+			+ "access module when they don't have \"ALL\" permission!";
 
-    private static final String SUBTREELEVEL = "subtree";
+	private static final String TOPLEVEL = "top";
 
-    private static final String RELATION = "Provides info for";
+	private static final String SUBTREELEVEL = "subtree";
 
-    private Logger logMetacat = Logger.getLogger(Eml210SAXHandler.class);   	   	
+	private static final String RELATION = "Provides info for";
 
-    /**
-     * Construct an instance of the handler class In this constructor, user can
-     * specify the version need to update
-     *
-     * @param conn the JDBC connection to which information is written
-     * @param action - "INSERT" or "UPDATE"
-     * @param docid to be inserted or updated into JDBC connection
-     * @param revision, the user specified the revision need to be update
-     * @param user the user connected to MetaCat servlet and owns the document
-     * @param groups the groups to which user belongs
-     * @param pub flag for public "read" access on document
-     * @param serverCode the serverid from xml_replication on which this
-     *            document resides.
-     *
-     */
-    public Eml210SAXHandler(DBConnection conn, String action, String docid,
-            String revision, String user, String[] groups, String pub,
-            int serverCode, String createDate, String updateDate) throws SAXException
-    {
-        super(conn, action, docid, revision, user, groups, pub, 
-                serverCode, createDate, updateDate);
-        // Get the unchangeable subtrees (user doesn't have write permission)
-        try {
-            PermissionController control = new PermissionController(docid
-                    + PropertyService.getProperty("document.accNumSeparator") + revision);
-            //unChangableSubTreeHash = getUnchangableSubTree(control, user,
-            // groups);
+	private Logger logMetacat = Logger.getLogger(Eml210SAXHandler.class);
 
-            //If the action is update and user doesn't have "ALL" permission
-            // we need to check if user can update access subtree
-            if (action.equals("UPDATE")
-                    && !control.hasPermission(user, groups,
-                            AccessControlInterface.ALLSTRING)) {
-                needToCheckAccessModule = true;
-                unChangeableAccessSubTreeVector = getAccessSubTreeListFromDB();
-            }
-        } catch (Exception e) {
-            throw new SAXException(e.getMessage());
-        }
-    }
+	/**
+	 * Construct an instance of the handler class In this constructor, user can
+	 * specify the version need to update
+	 * 
+	 * @param conn
+	 *            the JDBC connection to which information is written
+	 * @param action -
+	 *            "INSERT" or "UPDATE"
+	 * @param docid
+	 *            to be inserted or updated into JDBC connection
+	 * @param revision,
+	 *            the user specified the revision need to be update
+	 * @param user
+	 *            the user connected to MetaCat servlet and owns the document
+	 * @param groups
+	 *            the groups to which user belongs
+	 * @param pub
+	 *            flag for public "read" access on document
+	 * @param serverCode
+	 *            the serverid from xml_replication on which this document
+	 *            resides.
+	 * 
+	 */
+	public Eml210SAXHandler(DBConnection conn, String action, String docid,
+			String revision, String user, String[] groups, String pub, int serverCode,
+			String createDate, String updateDate) throws SAXException {
+		super(conn, action, docid, revision, user, groups, pub, serverCode, createDate,
+				updateDate);
+		// Get the unchangeable subtrees (user doesn't have write permission)
+		try {
+			PermissionController control = new PermissionController(docid
+					+ PropertyService.getProperty("document.accNumSeparator") + revision);
+			// unChangableSubTreeHash = getUnchangableSubTree(control, user,
+			// groups);
 
-    // MCD - Removed the following method.  It is used for node level access control
-    // which is not yet implemented in EML 2.1.0
-    //    /* Pass a permission control and get the list of unchangable subtree */
-    //    private Hashtable getUnchangableSubTree(PermissionController controller,
-    //            String user, String[] groups) throws Exception
-    //    {
-    //        Hashtable list = null;
-    //        Hashtable result = new Hashtable();
-    //        // get unwritable sutree from controller
-    //        list = null;
-    //        // changed after old code removal
-    //        //controller.hasUnaccessableSubTree(user, groups,
-    //        //        AccessControlInterface.WRITESTRING);
-    //        if (list != null) {
+			// If the action is update and user doesn't have "ALL" permission
+			// we need to check if user can update access subtree			
+			if (!control.hasPermission(user, groups, AccessControlInterface.ALLSTRING)
+					&& action != null && action.equals("UPDATE")) {
+				needToCheckAccessModule = true;
+				unChangeableAccessSubTreeVector = getAccessSubTreeListFromDB();
+			}
+
+		} catch (Exception e) {
+			throw new SAXException(e.getMessage());
+		}
+	}
+
+	// MCD - Removed the following method. It is used for node level access
+	// control
+	// which is not yet implemented in EML 2.1.0
+	// /* Pass a permission control and get the list of unchangable subtree */
+	// private Hashtable getUnchangableSubTree(PermissionController controller,
+	// String user, String[] groups) throws Exception
+	// {
+	// Hashtable list = null;
+	// Hashtable result = new Hashtable();
+	// // get unwritable sutree from controller
+	// list = null;
+	// // changed after old code removal
+	// //controller.hasUnaccessableSubTree(user, groups,
+	// // AccessControlInterface.WRITESTRING);
+	// if (list != null) {
 	//
-    //            Enumeration en = list.elements();
-    //            while (en.hasMoreElements()) {
-    //                // Get a subtree without node record list
-    //                SubTree treeWithoutStack = (SubTree) en.nextElement();
-    //                String subTreeId = treeWithoutStack.getSubTreeId();
-    //                logMetacat.info(
-    //                        "unchangable subtree id: " + subTreeId);
-    //                long startNodeId = treeWithoutStack.getStartNodeId();
-    //                logMetacat.info("unchangable subtree startnodeid: "
-    //                        + startNodeId);
-    //                long endNodeId = treeWithoutStack.getEndNodeId();
-    //                logMetacat.info("unchangable subtree endnodeid: "
-    //                        + endNodeId);
-    //                // Get a subtree has the nodelist
-    //                SubTree tree = new SubTree(docid, subTreeId, startNodeId,
-    //                        endNodeId);
-    //                // add this tree to the result
-    //                result.put(subTreeId, tree);
-    //
-    //            }//while
-    //
-    //        }//if
-    //
-    //        return result;
-    //    }
+	// Enumeration en = list.elements();
+	// while (en.hasMoreElements()) {
+	// // Get a subtree without node record list
+	// SubTree treeWithoutStack = (SubTree) en.nextElement();
+	// String subTreeId = treeWithoutStack.getSubTreeId();
+	// logMetacat.info(
+	// "unchangable subtree id: " + subTreeId);
+	// long startNodeId = treeWithoutStack.getStartNodeId();
+	// logMetacat.info("unchangable subtree startnodeid: "
+	// + startNodeId);
+	// long endNodeId = treeWithoutStack.getEndNodeId();
+	// logMetacat.info("unchangable subtree endnodeid: "
+	// + endNodeId);
+	// // Get a subtree has the nodelist
+	// SubTree tree = new SubTree(docid, subTreeId, startNodeId,
+	// endNodeId);
+	// // add this tree to the result
+	// result.put(subTreeId, tree);
+	//
+	// }//while
+	//
+	// }//if
+	//
+	// return result;
+	// }
 
-    /*
-     * Get the subtree node info from xml_accesssubtree table
-     */
-    private Vector<AccessSection> getAccessSubTreeListFromDB() throws Exception
-    {
-        Vector<AccessSection> result = new Vector<AccessSection>();
-        PreparedStatement pstmt = null;
-        ResultSet rs = null;
-        String sql = "SELECT controllevel, subtreeid, startnodeid, endnodeid "
-                + "FROM xml_accesssubtree WHERE docid like ? "
-                + "ORDER BY startnodeid ASC";
+	/*
+	 * Get the subtree node info from xml_accesssubtree table
+	 */
+	private Vector<AccessSection> getAccessSubTreeListFromDB() throws Exception {
+		Vector<AccessSection> result = new Vector<AccessSection>();
+		PreparedStatement pstmt = null;
+		ResultSet rs = null;
+		String sql = "SELECT controllevel, subtreeid, startnodeid, endnodeid "
+				+ "FROM xml_accesssubtree WHERE docid like ? "
+				+ "ORDER BY startnodeid ASC";
 
-        try {
+		try {
 
-            pstmt = connection.prepareStatement(sql);
-            // Increase DBConnection usage count
-            connection.increaseUsageCount(1);
-            // Bind the values to the query
-            pstmt.setString(1, docid);
-            pstmt.execute();
+			pstmt = connection.prepareStatement(sql);
+			// Increase DBConnection usage count
+			connection.increaseUsageCount(1);
+			// Bind the values to the query
+			pstmt.setString(1, docid);
+			pstmt.execute();
 
-            // Get result set
-            rs = pstmt.getResultSet();
-            while (rs.next()) {
-                String level = rs.getString(1);
-                String sectionId = rs.getString(2);
-                long startNodeId = rs.getLong(3);
-                long endNodeId = rs.getLong(4);
-                // create a new access section
-                AccessSection accessObj = new AccessSection();
-                accessObj.setControlLevel(level);
-                accessObj.setDocId(docid);
-                accessObj.setSubTreeId(sectionId);
-                accessObj.setStartNodeId(startNodeId);
-                accessObj.setEndNodeId(endNodeId);
-                Stack<NodeRecord> nodeStack = accessObj.getSubTreeNodeStack();
-                accessObj.setSubTreeNodeStack(nodeStack);
-                // add this access obj into vector
-                result.add(accessObj);
-                // Get the top level access subtree control
-                if (level != null && level.equals(TOPLEVEL)) {
-                    topAccessSection = accessObj;
-                }
-            }
-            pstmt.close();
-        }//try
-        catch (SQLException e) {
-            throw new SAXException(
-                    "EMLSAXHandler.getAccessSubTreeListFromDB(): "
-                            + e.getMessage());
-        }//catch
-        finally {
-            try {
-                pstmt.close();
-            } catch (SQLException ee) {
-                throw new SAXException(
-                        "EMLSAXHandler.getAccessSubTreeListFromDB(): "
-                                + ee.getMessage());
-            }
-        }//finally
-        return result;
-    }
+			// Get result set
+			rs = pstmt.getResultSet();
+			while (rs.next()) {
+				String level = rs.getString(1);
+				String sectionId = rs.getString(2);
+				long startNodeId = rs.getLong(3);
+				long endNodeId = rs.getLong(4);
+				// create a new access section
+				AccessSection accessObj = new AccessSection();
+				accessObj.setControlLevel(level);
+				accessObj.setDocId(docid);
+				accessObj.setSubTreeId(sectionId);
+				accessObj.setStartNodeId(startNodeId);
+				accessObj.setEndNodeId(endNodeId);
+				Stack<NodeRecord> nodeStack = accessObj.getSubTreeNodeStack();
+				accessObj.setSubTreeNodeStack(nodeStack);
+				// add this access obj into vector
+				result.add(accessObj);
+				// Get the top level access subtree control
+				if (level != null && level.equals(TOPLEVEL)) {
+					topAccessSection = accessObj;
+				}
+			}
+			pstmt.close();
+		}// try
+		catch (SQLException e) {
+			throw new SAXException("EMLSAXHandler.getAccessSubTreeListFromDB(): "
+					+ e.getMessage());
+		}// catch
+		finally {
+			try {
+				pstmt.close();
+			} catch (SQLException ee) {
+				throw new SAXException("EMLSAXHandler.getAccessSubTreeListFromDB(): "
+						+ ee.getMessage());
+			}
+		}// finally
+		return result;
+	}
 
-    /** SAX Handler that is called at the start of each XML element */
-    public void startElement(String uri, String localName, String qName,
-            Attributes atts) throws SAXException
-    {
-        // for element <eml:eml...> qname is "eml:eml", local name is "eml"
-        // for element <acl....> both qname and local name is "eml"
-        // uri is namesapce
-        logMetacat.debug("Start ELEMENT(qName) " + qName);
-        logMetacat.debug("Start ELEMENT(localName) " + localName);
-        logMetacat.debug("Start ELEMENT(uri) " + uri);
+	/** SAX Handler that is called at the start of each XML element */
+	public void startElement(String uri, String localName, String qName, Attributes atts)
+			throws SAXException {
+		// for element <eml:eml...> qname is "eml:eml", local name is "eml"
+		// for element <acl....> both qname and local name is "eml"
+		// uri is namesapce
+		logMetacat.debug("Start ELEMENT(qName) " + qName);
+		logMetacat.debug("Start ELEMENT(localName) " + localName);
+		logMetacat.debug("Start ELEMENT(uri) " + uri);
 
-        DBSAXNode parentNode = null;
-        DBSAXNode currentNode = null;
+		DBSAXNode parentNode = null;
+		DBSAXNode currentNode = null;
 
-        if (!handleInlineData) {
-            // Get a reference to the parent node for the id
-            try {
-                parentNode = (DBSAXNode) nodeStack.peek();
-            } catch (EmptyStackException e) {
-                parentNode = null;
-            }
+		if (!handleInlineData) {
+			// Get a reference to the parent node for the id
+			try {
+				parentNode = (DBSAXNode) nodeStack.peek();
+			} catch (EmptyStackException e) {
+				parentNode = null;
+			}
 
-            //start handle inline data
-            if (localName.equals(INLINE)) {
-                handleInlineData = true;
-                //initialize namespace hash for in line data
-                inlineDataNameSpace = new Hashtable<String,String>();
-                //initialize file writer
-                String docidWithoutRev = MetaCatUtil.getDocIdFromString(docid);
-                String seperator = ".";
-                try {
-                seperator = PropertyService.getProperty("document.accNumSeparator");
-                } catch (PropertyNotFoundException pnfe) {
-                	logMetacat.error("Could not fing property 'accNumSeparator'. " 
-                			+ "Setting separator to '.': " + pnfe.getMessage());
-                }
-                // the new file name will look like docid.rev.2
-                inlineDataFileName = docidWithoutRev + seperator + revision + seperator
+			// start handle inline data
+			if (localName.equals(INLINE)) {
+				handleInlineData = true;
+				// initialize namespace hash for in line data
+				inlineDataNameSpace = new Hashtable<String, String>();
+				// initialize file writer
+				String docidWithoutRev = MetaCatUtil.getDocIdFromString(docid);
+				String seperator = ".";
+				try {
+					seperator = PropertyService.getProperty("document.accNumSeparator");
+				} catch (PropertyNotFoundException pnfe) {
+					logMetacat.error("Could not fing property 'accNumSeparator'. "
+							+ "Setting separator to '.': " + pnfe.getMessage());
+				}
+				// the new file name will look like docid.rev.2
+				inlineDataFileName = docidWithoutRev + seperator + revision + seperator
 						+ distributionIndex;
-                inlineDataFileWriter = createInlineDataFileWriter(inlineDataFileName);
-                // put the inline file id into a vector. If upload failed,
-                // metacat will delete the inline data file
-                inlineFileIdList.add(inlineDataFileName);
+				inlineDataFileWriter = createInlineDataFileWriter(inlineDataFileName);
+				// put the inline file id into a vector. If upload failed,
+				// metacat will delete the inline data file
+				inlineFileIdList.add(inlineDataFileName);
+				
+				currentDistributionSection.setDistributionType(DistributionSection.INLINE_DATA_DISTRIBUTION);
+				currentDistributionSection.setDataFileName(inlineDataFileName);
 
-            }
+			}
 
-            // If hit a text node, we need write this text for current's parent
-            // node This will happen if the element is mixed
-            if (hitTextNode && parentNode != null) {
-                // MCD - Removed the following method.  It is used for node level access control
-                // which is not yet implemented in EML 2.1.0
-                // //compare text node data for unchangeablesubtree
-            	// if (startCriticalSubTree) {
-            	//     compareTextNode(currentUnChangeableSubtreeNodeStack,
-            	//             textBuffer, PERMISSIONERROR);
-            	// }//if
+			// If hit a text node, we need write this text for current's parent
+			// node This will happen if the element is mixed
+			if (hitTextNode && parentNode != null) {
+				// MCD - Removed the following method. It is used for node level
+				// access control
+				// which is not yet implemented in EML 2.1.0
+				// //compare text node data for unchangeablesubtree
+				// if (startCriticalSubTree) {
+				// compareTextNode(currentUnChangeableSubtreeNodeStack,
+				// textBuffer, PERMISSIONERROR);
+				// }//if
 
-                //compare top level access module
-                if (processTopLevelAccess && needToCheckAccessModule) {
-                    compareTextNode(currentUnchangeableAccessModuleNodeStack,
-                            textBuffer, UPDATEACCESSERROR);
-                }
+				// compare top level access module
+				if (processTopLevelAccess && needToCheckAccessModule) {
+					compareTextNode(currentUnchangeableAccessModuleNodeStack, textBuffer,
+							UPDATEACCESSERROR);
+				}
 
-                if (needToCheckAccessModule
-                        && (processAdditionalAccess || processOtherAccess || processTopLevelAccess)) {
-                    // stored the pull out nodes into storedNode stack
-                    NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "TEXT",
-                            null, null, MetaCatUtil.normalize(textBuffer
-                                    .toString()));
-                    storedAccessNodeStack.push(nodeElement);
+				if (needToCheckAccessModule
+						&& (processAdditionalAccess || processOtherAccess || processTopLevelAccess)) {
+					// stored the pull out nodes into storedNode stack
+					NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "TEXT", null,
+							null, MetaCatUtil.normalize(textBuffer.toString()));
+					storedAccessNodeStack.push(nodeElement);
 
-                }
+				}
 
-                // write the textbuffer into db for parent node.
-                endNodeId = writeTextForDBSAXNode(endNodeId, textBuffer,
-                        parentNode);
-                // rest hitTextNode
-                hitTextNode = false;
-                // reset textbuffer
-                textBuffer = null;
-                textBuffer = new StringBuffer();
+				// write the textbuffer into db for parent node.
+				endNodeId = writeTextForDBSAXNode(endNodeId, textBuffer, parentNode);
+				// rest hitTextNode
+				hitTextNode = false;
+				// reset textbuffer
+				textBuffer = null;
+				textBuffer = new StringBuffer();
 
-            }
+			}
 
-            // Document representation that points to the root document node
-            if (atFirstElement) {
-                atFirstElement = false;
-                // If no DOCTYPE declaration: docname = root element
-                // doctype = root element name or name space
-                if (docname == null) {
-                    docname = localName;
-                    // if uri isn't null doctype = uri(namespace)
-                    // othewise root element
-                    if (uri != null && !(uri.trim()).equals("")) {
-                        doctype = uri;
-                    } else {
-                        doctype = docname;
-                    }
-                    logMetacat.debug("DOCNAME-a: " + docname);
-                    logMetacat.debug("DOCTYPE-a: " + doctype);
-                } else if (doctype == null) {
-                    // because docname is not null and it is declared in dtd
-                    // so could not be in schema, no namespace
-                    doctype = docname;
-                    logMetacat.debug("DOCTYPE-b: " + doctype);
-                }
-                rootNode.writeNodename(docname);
-                try {
-                    // for validated XML Documents store a reference to XML DB
-                    // Catalog. Because this is select statement and it needn't 
-                	// roll back if insert document action failed. In order to 
-                	// decrease DBConnection usage count, we get a new
-                    // dbconnection from pool String catalogid = null;
-                    DBConnection dbConn = null;
-                    int serialNumber = -1;
+			// Document representation that points to the root document node
+			if (atFirstElement) {
+				atFirstElement = false;
+				// If no DOCTYPE declaration: docname = root element
+				// doctype = root element name or name space
+				if (docname == null) {
+					docname = localName;
+					// if uri isn't null doctype = uri(namespace)
+					// othewise root element
+					if (uri != null && !(uri.trim()).equals("")) {
+						doctype = uri;
+					} else {
+						doctype = docname;
+					}
+					logMetacat.debug("DOCNAME-a: " + docname);
+					logMetacat.debug("DOCTYPE-a: " + doctype);
+				} else if (doctype == null) {
+					// because docname is not null and it is declared in dtd
+					// so could not be in schema, no namespace
+					doctype = docname;
+					logMetacat.debug("DOCTYPE-b: " + doctype);
+				}
+				rootNode.writeNodename(docname);
+				try {
+					// for validated XML Documents store a reference to XML DB
+					// Catalog. Because this is select statement and it needn't
+					// roll back if insert document action failed. In order to
+					// decrease DBConnection usage count, we get a new
+					// dbconnection from pool String catalogid = null;
+					DBConnection dbConn = null;
+					int serialNumber = -1;
 
-                    try {
-                        // Get dbconnection
-                        dbConn = DBConnectionPool
-                                .getDBConnection("DBSAXHandler.startElement");
-                        serialNumber = dbConn.getCheckOutSerialNumber();
+					try {
+						// Get dbconnection
+						dbConn = DBConnectionPool
+								.getDBConnection("DBSAXHandler.startElement");
+						serialNumber = dbConn.getCheckOutSerialNumber();
 
-                        Statement stmt = dbConn.createStatement();
-                        ResultSet rs = stmt
-                                .executeQuery("SELECT catalog_id FROM xml_catalog "
-                                        + "WHERE entry_type = 'Schema' "
-                                        + "AND public_id = '" + doctype + "'");
-                        boolean hasRow = rs.next();
-                        if (hasRow) {
-                            catalogid = rs.getString(1);
-                        }
-                        stmt.close();
-                    }//try
-                    finally {
-                        // Return dbconnection
-                        DBConnectionPool.returnDBConnection(dbConn,
-                                serialNumber);
-                    }//finally
+						Statement stmt = dbConn.createStatement();
+						ResultSet rs = stmt
+								.executeQuery("SELECT catalog_id FROM xml_catalog "
+										+ "WHERE entry_type = 'Schema' "
+										+ "AND public_id = '" + doctype + "'");
+						boolean hasRow = rs.next();
+						if (hasRow) {
+							catalogid = rs.getString(1);
+						}
+						stmt.close();
+					}// try
+					finally {
+						// Return dbconnection
+						DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+					}// finally
 
-                    //create documentImpl object by the constructor which can
-                    // specify the revision
-                    if (!super.getIsRevisionDoc())
-                    {
-                       currentDocument = new DocumentImpl(connection, rootNode
-                            .getNodeID(), docname, doctype, docid, revision,
-                            action, user, this.pub, catalogid, this.serverCode, 
-                            createDate, updateDate);
-                    }
-                   
-                } catch (Exception ane) {
-                    throw (new SAXException(
-                            "Error in EMLSaxHandler.startElement " + action,
-                            ane));
-                }
-            }
+					// create documentImpl object by the constructor which can
+					// specify the revision
+					if (!super.getIsRevisionDoc()) {
+						currentDocument = new DocumentImpl(connection, rootNode
+								.getNodeID(), docname, doctype, docid, revision, action,
+								user, this.pub, catalogid, this.serverCode, createDate,
+								updateDate);
+					}
 
-            // Create the current node representation
-            currentNode = new DBSAXNode(connection, qName, localName,
-                    parentNode, rootNode.getNodeID(), docid, doctype);
-            // Use a local variable to store the element node id
-            // If this element is a start point of subtree(section), it will be
-            // stored otherwise, it will be discarded
-            long startNodeId = currentNode.getNodeID();
-            // Add all of the namespaces
-            String prefix = null;
-            String nsuri = null;
-            Enumeration<String> prefixes = namespaces.keys();
-            while (prefixes.hasMoreElements()) {
-                prefix = prefixes.nextElement();
-                nsuri = namespaces.get(prefix);
-                endNodeId = currentNode.setNamespace(prefix, nsuri, docid);
-            }
+				} catch (Exception ane) {
+					throw (new SAXException("Error in EMLSaxHandler.startElement "
+							+ action, ane));
+				}
+			}
 
-            // Add all of the attributes
-            for (int i = 0; i < atts.getLength(); i++) {
-                String attributeName = atts.getQName(i);
-                String attributeValue = atts.getValue(i);
-                endNodeId = currentNode.setAttribute(attributeName,
-                        attributeValue, docid);
+			// Create the current node representation
+			currentNode = new DBSAXNode(connection, qName, localName, parentNode,
+					rootNode.getNodeID(), docid, doctype);
+			// Use a local variable to store the element node id
+			// If this element is a start point of subtree(section), it will be
+			// stored otherwise, it will be discarded
+			long startNodeId = currentNode.getNodeID();
+			// Add all of the namespaces
+			String prefix = null;
+			String nsuri = null;
+			Enumeration<String> prefixes = namespaces.keys();
+			while (prefixes.hasMoreElements()) {
+				prefix = prefixes.nextElement();
+				nsuri = namespaces.get(prefix);
+				endNodeId = currentNode.setNamespace(prefix, nsuri, docid);
+			}
 
-                // To handle name space and schema location if the attribute
-                // name is xsi:schemaLocation. If the name space is in not 
-                // in catalog table it will be registered.
-                if (attributeName != null
-                        && attributeName
-                                .indexOf(MetaCatServlet.SCHEMALOCATIONKEYWORD) != -1) {
-                    SchemaLocationResolver resolver = new SchemaLocationResolver(
-                            attributeValue);
-                    resolver.resolveNameSpace();
+			// Add all of the attributes
+			for (int i = 0; i < atts.getLength(); i++) {
+				String attributeName = atts.getQName(i);
+				String attributeValue = atts.getValue(i);
+				endNodeId = currentNode
+						.setAttribute(attributeName, attributeValue, docid);
 
-                } else if (attributeName != null && attributeName.equals(ID)) {
-                    // MCD - Removed the following code.  It is used for node level access 
-                	// control which is not yet implemented in EML 2.1.0
-                    // // check unchangeable subtree hash if contains this
-                	// // subtree id
-                	// if (unChangeableSubTreeHash.containsKey(attributeValue)) {
-                	//     // this subtree couldn't be changed by the user and
-                	//     // move it from hash
-                	//     SubTree currentUnChangedableSubtree = unChangeableSubTreeHash
-                	//             .remove(attributeValue);
-                	//     currentUnChangeableSubtreeNodeStack = currentUnChangedableSubtree
-                	//             .getSubTreeNodeStack();
-                	//     startCriticalSubTree = true;
-                	//     firstElementForCriticalSubTree = true;
-                	// }
-                }
-            }//for
+				// To handle name space and schema location if the attribute
+				// name is xsi:schemaLocation. If the name space is in not
+				// in catalog table it will be registered.
+				if (attributeName != null
+						&& attributeName.indexOf(MetaCatServlet.SCHEMALOCATIONKEYWORD) != -1) {
+					SchemaLocationResolver resolver = new SchemaLocationResolver(
+							attributeValue);
+					resolver.resolveNameSpace();
 
-            // handle access stuff
-            if (localName.equals(ACCESS)) {
-            	if (parentNode.getTagName().equals(EML)) {
+				} else if (attributeName != null && attributeName.equals(ID)) {
+					// MCD - Removed the following code. It is used for node
+					// level access
+					// control which is not yet implemented in EML 2.1.0
+					// // check unchangeable subtree hash if contains this
+					// // subtree id
+					// if (unChangeableSubTreeHash.containsKey(attributeValue))
+					// {
+					// // this subtree couldn't be changed by the user and
+					// // move it from hash
+					// SubTree currentUnChangedableSubtree =
+					// unChangeableSubTreeHash
+					// .remove(attributeValue);
+					// currentUnChangeableSubtreeNodeStack =
+					// currentUnChangedableSubtree
+					// .getSubTreeNodeStack();
+					// startCriticalSubTree = true;
+					// firstElementForCriticalSubTree = true;
+					// }
+				}
+			}// for
+
+			// handle access stuff
+			if (localName.equals(ACCESS)) {
+				if (parentNode.getTagName().equals(EML)) {
 					processTopLevelAccess = true;
 				} else if (parentNode.getTagName() == DISTRIBUTION) {
 					processAdditionalAccess = true;
